package com.ringlord.boxer2.swing7;

import java.util.List;
import java.util.logging.Level;

import javax.swing.SwingUtilities;
import javax.swing.ToolTipManager;
import javax.swing.UIManager;

import com.ringlord.boxer2.Project;
import com.ringlord.boxer2.Util;


public class Launch
{
  public static void main( final String[] args )
  {
    go( null );
  }


  public static void go( final List<Project> projects )
  {
    if( (projects == null) || projects.isEmpty() )
      {
        SwingUtilities.invokeLater( new Runnable()
        {
          @Override
          public void run()
          {
            try
              {
                final String osName = System.getProperties().getProperty( "os.name" ).toUpperCase();
                if( (osName.indexOf( "WINDOWS" ) > -1) || // Microsoft® Windows®
                    (osName.indexOf( "MAC OS X" ) > -1) ) // Apple® Mac OS/X
                  {
                    // Use the platform look and feel
                    UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
                  }
                else
                  {
                    // For all other platforms use Nimbus
                    UIManager.setLookAndFeel( "javax.swing.plaf.nimbus.NimbusLookAndFeel" );
                  }
              }
            catch( final Exception x )
              {
                // Stay with whatever default Java has picked
              }
            ToolTipManager.sharedInstance().setDismissDelay( 30000 );
            new ProjectSelect().setVisible( true );
          }
        } );
      }
    else
      {
        Util.logger().log( Level.SEVERE,
                           "Cannot yet launch Builder with a GUI" );
      }
  }
}
