package com.ringlord.boxer2.swing7;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;

import com.ringlord.boxer2.SigningProperties.PasswordReader;


public class PasswordReaderGUI
  implements
    PasswordReader
{
  public PasswordReaderGUI( final JComponent parent )
  {
    super();
    this.parent = parent;
  }


  @Override
  public String readPassword()
  {
    final JPasswordField accessPassword = new JPasswordField( 16 );
    final JPanel accessInfo = new JPanel( new GridLayout( 0,
                                                          1 ) );
    accessInfo.add( new JLabel( "Some of the file's contents are encrypted." ) );
    accessInfo.add( new JLabel( "You must provide the password to access" ) );
    accessInfo.add( new JLabel( "these settings:" ) );
    accessInfo.setBorder( BorderFactory.createEmptyBorder( 0,
                                                           0,
                                                           8,
                                                           0 ) );

    final JPanel accessComponent = new JPanel( new BorderLayout() );
    accessComponent.add( BorderLayout.NORTH,
                         accessInfo );
    accessComponent.add( BorderLayout.SOUTH,
                         accessPassword );

    // focused is a final (so it can be accessed inside the
    // nested classes), but its content can be modified, so it
    // is a final that isn't really final.
    final boolean[] focused = {false};
    accessComponent.addAncestorListener( new AncestorListener()
    {
      @Override
      public void ancestorRemoved( final AncestorEvent event )
      {
      }


      @Override
      public void ancestorMoved( final AncestorEvent event )
      {
      }


      @Override
      public void ancestorAdded( final AncestorEvent event )
      {
        focused[0] = true;
        accessPassword.requestFocusInWindow();
        accessPassword.removeAncestorListener( this );
      }
    } );
    accessPassword.addFocusListener( new FocusListener()
    {
      @Override
      public void focusGained( final FocusEvent e )
      {
      }


      @Override
      public void focusLost( final FocusEvent e )
      {
        if( focused[0] )
          {
            accessPassword.requestFocusInWindow();
            accessPassword.removeFocusListener( this );
          }
      }
    } );

    final String[] choices = {"Okay","Cancel"};
    final int n = JOptionPane.showOptionDialog( parent,
                                                accessComponent,
                                                "Password Required",
                                                JOptionPane.YES_NO_OPTION,
                                                JOptionPane.QUESTION_MESSAGE,
                                                null,
                                                choices,
                                                choices[0] );
    if( n == JOptionPane.YES_OPTION )
      {
        final String password = new String( accessPassword.getPassword() );
        return (password.length() == 0
            ? null
            : password);
      }
    return null;
  }

  private final JComponent parent;

}
